/* Converts S3 records into S1 records */

#include <stdio.h>
#include <stdlib.h>

int main(int argc, char *argv[])
{
  char *progname;		//Used to get program name
  char *filein;			//Used to get input S3 file
  char *fileout;		//Used to produce output S1 file
  FILE *fileinptr;		//Input file pointer
  FILE *fileoutptr;		//Output file pointer
  char charsin[] = {1,1}; 	//Input character array
  unsigned int hexin = 0xAA;	//Used for hex input
  unsigned int hexin2 = 0xAA;   //Used for other hex input
  unsigned int is_end = 1;      //Used for end of file

  progname = *argv++;		//Get program name
  filein = *argv++;		//Get input filename
  fileout = *argv++;		//Get output filename

  fileinptr = fopen(filein,"r");	//Open input for reading
  fileoutptr = fopen(fileout,"w");	//Open output for writing

  while(is_end != EOF)
  {
    is_end = fscanf(fileinptr,"%2s",&charsin);	

    if(charsin[0] == 'S' && charsin[1] == '0')
    {
      printf("Ignored S0 header record\n");
    }

    else if(charsin[0] == 'S' && charsin[1] == '3')
    {
      charsin[0] = 'S';
      charsin[1] = '1';
      fprintf(fileoutptr,"%2s",charsin);
      is_end = fscanf(fileinptr,"%2x",&hexin);
      hexin--;			//ignore the upper 2 bytes
      hexin--;			//in the 4-byte address
      is_end = fscanf(fileinptr,"%2x",&hexin2);
      is_end = fscanf(fileinptr,"%2x",&hexin2);
      
      fprintf(fileoutptr,"%.2x",hexin);

      for(hexin;hexin > 0;hexin--)
      {
        is_end = fscanf(fileinptr,"%2x",&hexin2);
	fprintf(fileoutptr,"%.2x",hexin2);
      }
  
      fprintf(fileoutptr,"\n");
    }
  }

  fclose(fileinptr);		//Close input file
  fclose(fileoutptr);		//Close output file
  return 0;			//End of main
}
